diff --git a/aserver/aserver.c b/aserver/aserver.c
index 73ea4e9..ca9aaf3 100644
--- a/aserver/aserver.c
+++ b/aserver/aserver.c
@@ -75,6 +75,7 @@ static int make_local_socket(const char *filename)
 	if (bind(sock, (struct sockaddr *) addr, size) < 0) {
 		int result = -errno;
 		SYSERROR("bind failed");
+		close(sock);
 		return result;
 	}
 
diff --git a/src/control/control_shm.c b/src/control/control_shm.c
index abab398..4083ec5 100644
--- a/src/control/control_shm.c
+++ b/src/control/control_shm.c
@@ -436,8 +436,11 @@ static int make_local_socket(const char *filename)
 	addr->sun_family = AF_LOCAL;
 	memcpy(addr->sun_path, filename, l);
 
-	if (connect(sock, (struct sockaddr *) addr, size) < 0)
+	if (connect(sock, (struct sockaddr *) addr, size) < 0){
+		SYSERR("connect failed");
+		close(sock);
 		return -errno;
+	}
 	return sock;
 }
 
diff --git a/src/pcm/pcm_shm.c b/src/pcm/pcm_shm.c
index 69d0524..3fbecca 100644
--- a/src/pcm/pcm_shm.c
+++ b/src/pcm/pcm_shm.c
@@ -649,6 +649,7 @@ static int make_local_socket(const char *filename)
 
 	if (connect(sock, (struct sockaddr *) addr, size) < 0) {
 		SYSERR("connect failed");
+		close(sock);
 		return -errno;
 	}
 	return sock;
